# Calc-Ultra

[![MIT License](https://img.shields.io/badge/License-MIT-green.svg)](https://opensource.org/license/mit/) [![Version](https://img.shields.io/badge/Version-1.3.7-blue.svg)](https://pypi.org/project/calc-ultra/)

> **Calculus made easy**

(Turn on dark mode for a better aesthetic) 📲

Calc-Ultra (styled as CALC ULTRA) is a multi-functional calculator that uses a command-line/menu-based interface. Little Python background knowledge is needed to use this calculator!

Supports:

- Simple calculations (complex numbers supported!)
- Derivatives
- Partials
- Implicit differentiation
- Limits
- Antiderivatives
- Definite integrals
- Improper integrals
- Double integrals
- Solving (sets) of equation(s)
- Vector/matrix operations
- **A perfect interface to do calculations!**  

## Chinese version

Want to check out the Chinese version? Visit the Chinese version [here](https://github.com/sudoer-Huatao/calc_ultra-chinese)! 🇨🇳

## Installation and Running

> Run the calculus calculator with a single line of code

Use the following command to install Calc-Ultra:

`pip3 install calc-ultra`

or

`python3 -m pip install calc-ultra` if you have lower versions of pip.

Due to Python import identifiers restrictions, please import Calc-Ultra as "calc_ultra" and not "calc-ultra".

Import Calc-Ultra like so to use:

`from calc_ultra import main`

Please make sure you have the latest version installed. To update calc-ultra, run the following command:

`pip3 install --upgrade calc-ultra`

## Requirements

Calc-Ultra requires these modules/packages to be installed:

- `sympy`
- `numpy`
- `matplotlib`
- `scipy`
- `rich`
- `prompt-toolkit`

If you do not have them installed, no need to worry! These modules should be installed automatically if you don't have them.

## Acknowledgements

> Without them, this would be impossible

A big thank-you to all GitHub users who gave feedback and/or starred this repository. ⭐️ Your encouragement is our motivation.
The following contributors deserve a SPECIAL THANK-YOU 👍❤️:

- [@Haobot](https://github.com/Haobot) for troubleshooting and feedback!
- [@FanboFB](https://github.com/FanboFB) for feedback and ideas for improvement!

This program was made using `sympy` for calculation and `numpy`, `scipy`, and `matplotlib` for graphing.

## Gallery (Demos)

Simple calculation screen demo:
![simple_calculation_screen_demo](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/9df15b7e-e239-4f99-8966-db684ff36b68 "simple_calculation_demo")

DerivaCalc derivative with graph demo:
![derivacalc_demo](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/d0491f48-1a4f-4538-be7e-0bf793815eff "derivacalc_demo")

InteCalc antiderivative with graph demo:
![intecalc_demo_1](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/2375f351-46ae-4bfd-ad25-af599a26bbce "intecalc_demo_1")

InteCalc definite integral with graph demo:
![intecalc_demo_2](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/0af601a5-3d4c-4db5-a2aa-dff4b6bdd4b5 "intecalc_demo_2")

LimCalc limit and one-sided limit demo:
![limcalc_demo](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/bdecb164-b28c-4b4c-9f0a-cf9c44dfad90 "limcalc_demo")

AlgCalc equation solver demo:
![algcalc_demo_1](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/74beffa8-7c82-4499-a114-8278e9929cdb "algcalc_demo_1")

AlgCalc vector operation demo:
![algcalc_demo_2](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/48b9624f-ab32-4f4c-99f7-1860dfd487a0 "algcalc_demo_2")

AlgCalc matrix operation demo:
![algcalc_demo_3](https://github.com/sudoer-Huatao/calc_ultra/assets/135504586/dee6cc8e-765d-4c41-b322-03f3ee501aac "algcalc_demo_3")

## License

This project is licensed under the terms of the MIT license.
